;+
;
; @file_comments
;
; @categories
;
; @param NAME
;
; @param DEBUT
;
; @param FIN
;
; @param NOMEXP
;
; @keyword PARENT
; same as DIALOG_PARENT de dialog_message.pro
;
; @keyword BOXZOOM
; Vector indicating the geographic zone on which we want to cut the map.
; If BOXZOOM has :
;   1 element : The extraction is made on [lon1, lon2, lat1, lat2, 0.,boxzoom[0]]
;   2 elements: The extraction is made on [lon1, lon2, lat1, lat2, boxzoom[0],boxzoom[1]]
;   4 elements: The extraction is made on [Boxzoom, 0, max([gdept, gdepw])]
;   5 elements: The extraction is made on [Boxzoom[0:3], 0, Boxzoom[4]]
;   6 elements: The extraction is made on Boxzoom
; Where lon1, lon2,lat1,lat2 are global variables defined at the last 
; <pro>domdef</pro> !
;
; @keyword _EXTRA
; Used to pass keywords
;
; @returns
;
; @uses
;
; @restrictions
;
; @examples
;
; @history
;
; @version
; $Id$
;
; @todo
; seb
;
;-
FUNCTION read_vermair, name, debut, fin, nomexp $
                     , PARENT=parent, BOXZOOM=boxzoom, _EXTRA=ex
;
  compile_opt idl2, strictarrsubs
;
@common
   if name EQ 'un' then name = 'vozocrtx'
   if name EQ 'vn' then name = 'vomecrty'
   if debut EQ fin then begin
      res = lec(name,debut,nomexp, BOXZOOM=boxzoom, _EXTRA = ex)
   ENDIF ELSE res = lect(name,debut,fin, nomexp, BOXZOOM=boxzoom, _EXTRA = ex)
;------------------------------------------------------------ 
   return, {tab:res, grille:vargrid, unite:'', experience:varexp, nom:varname}
end
